<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
  "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.railway.business.catenary.mapper.BusJcebLbjghjlMapper">

  <resultMap id="BaseResultMap" type="com.railway.business.catenary.domain.BusJcebLbjghjl">
    <result column="id" property="id"/>
    <result column="station_id" property="stationId"/>
    <result column="station_name" property="stationName"/>
    <result column="dept_station_id" property="deptStationId"/>
    <result column="dd" property="dd"/>
    <result column="ghq_mc" property="ghqMc"/>
    <result column="ghq_ggxh" property="ghqGgxh"/>
    <result column="ghq_sccj" property="ghqSccj"/>
    <result column="ghh_mc" property="ghhMc"/>
    <result column="ghh_ggxh" property="ghhGgxh"/>
    <result column="ghh_sccj" property="ghhSccj"/>
    <result column="ghyy" property="ghyy"/>
    <result column="operation_date" property="operationDate"/>
    <result column="operator" property="operator"/>
    <result column="remark" property="remark"/>
    <result column="submit_state" property="submitState"/>
    <result column="del_flag" property="delFlag"/>
    <result column="create_by" property="createBy"/>
    <result column="create_time" property="createTime"/>
    <result column="update_by" property="updateBy"/>
    <result column="update_time" property="updateTime"/>
  </resultMap>

  <sql id="Base_Column_List">
    id,
    dept_station_id,
    station_name,
    dd,
    ghq_mc,
    ghq_ggxh,
    ghq_sccj,
    ghh_mc,
    ghh_ggxh,
    ghh_sccj,
    ghyy,
    operation_date,
    operator,
    remark,
    submit_state,
    del_flag,
    create_by,
    create_time,
    update_by,
    update_time
  </sql>

  <insert id="insert" parameterType="com.railway.business.catenary.domain.BusJcebLbjghjl">
    <selectKey keyProperty="id" order="AFTER" resultType="Long">
      select @@IDENTITY as id
    </selectKey>
    INSERT INTO bus_jceb_lbjghjl
    <trim prefix="(" suffix=")" suffixOverrides=",">
      <if test='null != deptStationId'>
        dept_station_id,
      </if>
      <if test='null != dd'>
        dd,
      </if>
      <if test='null != ghqMc'>
        ghq_mc,
      </if>
      <if test='null != ghqGgxh'>
        ghq_ggxh,
      </if>
      <if test='null != ghqSccj'>
        ghq_sccj,
      </if>
      <if test='null != ghhMc'>
        ghh_mc,
      </if>
      <if test='null != ghhGgxh'>
        ghh_ggxh,
      </if>
      <if test='null != ghhSccj'>
        ghh_sccj,
      </if>
      <if test='null != ghyy'>
        ghyy,
      </if>
      <if test='null != operationDate'>
        operation_date,
      </if>
      <if test='null != operator'>
        operator,
      </if>
      <if test='null != remark'>
        remark,
      </if>
      <if test='null != submitState'>
        submit_state,
      </if>
      <if test='null != delFlag'>
        del_flag,
      </if>
      <if test='null != createBy'>
        create_by,
      </if>
      <if test='null != createTime'>
        create_time,
      </if>
      <if test='null != updateBy'>
        update_by,
      </if>
      <if test='null != updateTime'>
        update_time
      </if>
    </trim>
    <trim prefix="values (" suffix=")" suffixOverrides=",">
      <if test='null != deptStationId'>
        #{deptStationId},
      </if>
      <if test='null != dd'>
        #{dd},
      </if>
      <if test='null != ghqMc'>
        #{ghqMc},
      </if>
      <if test='null != ghqGgxh'>
        #{ghqGgxh},
      </if>
      <if test='null != ghqSccj'>
        #{ghqSccj},
      </if>
      <if test='null != ghhMc'>
        #{ghhMc},
      </if>
      <if test='null != ghhGgxh'>
        #{ghhGgxh},
      </if>
      <if test='null != ghhSccj'>
        #{ghhSccj},
      </if>
      <if test='null != ghyy'>
        #{ghyy},
      </if>
      <if test='null != operationDate'>
        #{operationDate},
      </if>
      <if test='null != operator'>
        #{operator},
      </if>
      <if test='null != remark'>
        #{remark},
      </if>
      <if test='null != submitState'>
        #{submitState},
      </if>
      <if test='null != delFlag'>
        #{delFlag},
      </if>
      <if test='null != createBy'>
        #{createBy},
      </if>
      <if test='null != createTime'>
        #{createTime},
      </if>
      <if test='null != updateBy'>
        #{updateBy},
      </if>
      <if test='null != updateTime'>
        #{updateTime}
      </if>
    </trim>
  </insert>

  <delete id="delete">
    UPDATE bus_jceb_lbjghjl
    set del_flag='1'
    WHERE id = #{id}
  </delete>

  <update id="update" parameterType="com.railway.business.catenary.domain.BusJcebLbjghjl">
    UPDATE bus_jceb_lbjghjl
    <set>
      <if test='null != deptStationId'>dept_station_id = #{deptStationId},</if>
      <if test='null != dd'>dd = #{dd},</if>
      <if test='null != ghqMc'>ghq_mc = #{ghqMc},</if>
      <if test='null != ghqGgxh'>ghq_ggxh = #{ghqGgxh},</if>
      <if test='null != ghqSccj'>ghq_sccj = #{ghqSccj},</if>
      <if test='null != ghhMc'>ghh_mc = #{ghhMc},</if>
      <if test='null != ghhGgxh'>ghh_ggxh = #{ghhGgxh},</if>
      <if test='null != ghhSccj'>ghh_sccj = #{ghhSccj},</if>
      <if test='null != ghyy'>ghyy = #{ghyy},</if>
      <if test='null != operationDate'>operation_date = #{operationDate},</if>
      <if test='null != operator'>operator = #{operator},</if>
      <if test='null != remark'>remark = #{remark},</if>
      <if test='null != submitState'>submit_state = #{submitState},</if>
      <if test='null != delFlag'>del_flag = #{delFlag},</if>
      <if test='null != updateBy'>update_by = #{updateBy},</if>
      <if test='null != updateTime'>update_time = #{updateTime}</if>
    </set>
    WHERE id = #{id}
  </update>


  <select id="getInfo" resultMap="BaseResultMap">
    SELECT
    DISTINCT
    v.dept_id, v.dept_name,
    v.line_id, v.line_name,
    v.station_name, v.station_id,
    t.*
    FROM bus_jceb_lbjghjl t
    LEFT JOIN v_station v ON t.dept_station_id = v.dept_station_id
    WHERE
    t.del_flag = '0'
    AND s.del_flag = '0'
    AND t.id = #{id}
  </select>

  <select id="getList" resultMap="BaseResultMap">
    SELECT
    v.dept_id, v.dept_name,
    v.line_id, v.line_name,
    v.station_name, v.station_id,
    t.*
    FROM bus_jceb_lbjghjl t
    LEFT JOIN v_station v ON t.dept_station_id = v.dept_station_id
    <where>
      t.del_flag = '0'
      <if test="deptId!=null and deptId!=''">
        and v.dept_id=#{deptId}
      </if>
      <if test="stationId!=null and stationId!=''">
        and v.station_id=#{stationId}
      </if>
      <if test="stationIds!=null and stationIds.length > 0">
        and v.station_id in
        <foreach collection="stationIds" item="stationId" index="i" open="(" separator="," close=")">
          #{stationId}
        </foreach>
      </if>
      <if test="dd!=null and dd!=''">
        and t.dd=#{dd}
      </if>
      <if test="ghqMc!=null and ghqMc!=''">
        and t.ghq_mc=#{ghqMc}
      </if>
      <if test="ghqGgxh!=null and ghqGgxh!=''">
        and t.ghq_ggxh=#{ghqGgxh}
      </if>
      <if test="ghqSccj!=null and ghqSccj!=''">
        and t.ghq_sccj=#{ghqSccj}
      </if>
      <if test="ghhMc!=null and ghhMc!=''">
        and t.ghh_mc=#{ghhMc}
      </if>
      <if test="ghhGgxh!=null and ghhGgxh!=''">
        and t.ghh_ggxh=#{ghhGgxh}
      </if>
      <if test="ghhSccj!=null and ghhSccj!=''">
        and t.ghh_sccj=#{ghhSccj}
      </if>
      <if test="ghyy!=null and ghyy!=''">
        and t.ghyy=#{ghyy}
      </if>
      <if test="operationDate!=null">
        and t.operation_date=#{operationDate}
      </if>
      <if test="operator!=null and operator!=''">
        and t.operator like concat('%', #{operator}, '%')
      </if>
      <if test="remark!=null and remark!=''">
        and t.remark=#{remark}
      </if>
      <if test="submitState!=null and submitState!=''">
        and t.submit_state <![CDATA[ >= ]]> #{submitState}
      </if>
      <if test="delFlag!=null and delFlag!=''">
        and t.del_flag=#{delFlag}
      </if>
      <if test="createBy!=null and createBy!=''">
        and t.create_by=#{createBy}
      </if>
      <if test="createTime!=null">
        and DATE_FORMAT(t.create_time, '%Y-%m-%d') = #{createTime}
      </if>
      <if test="updateBy!=null and updateBy!=''">
        and t.update_by=#{updateBy}
      </if>
      <if test="updateTime!=null">
        and DATE_FORMAT(t.update_time, '%Y-%m-%d') = #{updateTime}
      </if>
    </where>
    <if test="orderBy!=null and orderBy!=''">
      order by t.${orderBy}
    </if>
    <if test="isAsc!=null and isAsc!=''">
      <if test="isAsc == '1'.toString()">
        asc
      </if>
      <if test="isAsc == '0'.toString()">
        desc
      </if>
    </if>
  </select>

  <select id="getJcebList" resultMap="BaseResultMap">
    SELECT
    v.dept_id, v.dept_name,
    v.line_id, v.line_name,
    v.station_name, v.station_id,
    t.*
    FROM bus_jceb_lbjghjl t
    LEFT JOIN v_station v ON t.dept_station_id = v.dept_station_id
    <where>
      t.del_flag='0'
      <if test="submitState!=null and submitState!=''">
        and t.submit_state <![CDATA[ >= ]]> #{submitState}
      </if>
      <if test="deptId!=null and deptId!=''">
        and v.dept_id=#{deptId}
      </if>
      <if test="stationId!=null and stationId!=''">
        and v.station_id=#{stationId}
      </if>
      <if test="stationIds!=null and stationIds.length > 0">
        and v.station_id in
        <foreach collection="stationIds" item="stationId" index="i" open="(" separator="," close=")">
          #{stationId}
        </foreach>
      </if>
      <if test="pillarCode!=null and pillarCode!=''">
        and t.pillar_start=#{pillarCode}
      </if>
      <if test="operator!=null and operator!=''">
        and t.operator like concat('%', #{operator}, '%')
      </if>
      <if test="createBy!=null and createBy!=''">
        and t.create_by=#{createBy}
      </if>
    </where>
  </select>

  <resultMap id="JcebResultMap" type="com.railway.business.catenary.domain.vo.JcebRecordVo">
    <result column="id" property="id"/>
    <result column="dept_name" property="deptName"/>
    <result column="station_name" property="stationName"/>
    <result column="operation_date" property="operationDate"/>
    <result column="operator" property="operator"/>
    <result column="jcebType" property="jcebType"/>
  </resultMap>

  <select id="getListByType" resultMap="JcebResultMap">
    SELECT t.id, v.dept_name, v.station_name, t.operation_date, t.operator, #{jcebType} as jcebType
    FROM bus_jceb_lbjghjl t
    LEFT JOIN v_station v on t.dept_station_id = v.dept_station_id
    <where>
      t.del_flag='0'
      <if test="submitState!=null and submitState!=''">
        and t.submit_state <![CDATA[ >= ]]> #{submitState}
      </if>
      <if test="deptId!=null and deptId!=''">
        and v.dept_id=#{deptId}
      </if>
      <if test="stationId!=null and stationId!=''">
        and v.station_id=#{stationId}
      </if>
      <if test="stationIds!=null and stationIds.length > 0">
        and v.station_id in
        <foreach collection="stationIds" item="stationId" index="i" open="(" separator="," close=")">
          #{stationId}
        </foreach>
      </if>
      <if test="pillarCode!=null and pillarCode!=''">
        and t.pillar_start=#{pillarCode}
      </if>
      <if test="operator!=null and operator!=''">
        and t.operator like concat('%', #{operator}, '%')
      </if>
      <if test="createBy!=null and createBy!=''">
        and t.create_by=#{createBy}
      </if>
    </where>
  </select>

  <resultMap id="JcebCountResultMap" type="com.railway.business.catenary.domain.vo.JcebCountVo">
    <result column="c" property="count"/>
    <result column="operation_date" property="operationDate"/>
  </resultMap>

  <select id="getCountByType" resultMap="JcebCountResultMap">
    SELECT count(*) c, max(t.operation_date) as operation_date
    FROM bus_jceb_lbjghjl t
    LEFT JOIN v_station v on t.dept_station_id = v.dept_station_id
    <where>
      t.del_flag='0'
      <if test="submitState!=null and submitState!=''">
        and t.submit_state <![CDATA[ >= ]]> #{submitState}
      </if>
      <if test="deptId!=null and deptId!=''">
        and v.dept_id=#{deptId}
      </if>
      <if test="stationId!=null and stationId!=''">
        and v.station_id=#{stationId}
      </if>
      <if test="pillarCode!=null and pillarCode!=''">
        and t.pillar_start=#{pillarCode}
      </if>
      <if test="operator!=null and operator!=''">
        and t.operator like concat('%', #{operator}, '%')
      </if>
      <if test="createBy!=null and createBy!=''">
        and t.create_by=#{createBy}
      </if>
    </where>
  </select>

</mapper>